Program RBIndex;
uses
 Objects, Memory, tpString, TextFile, RevPos, GetID, CRT;

type
 PIdxItem = ^TIdxItem;
 TIdxItem = record
  Topic: PString;
  Pos: Longint;
  Owner: PString;
 end;

 PIdxColl = ^TIdxColl;     {Topic index collection}
 TIdxColl = Object(TSortedCollection)
  SoftSort: Boolean;
  function Compare(Key1, Key2: Pointer): Integer; virtual;
  procedure FreeItem(Item: Pointer); virtual;
 end;

 PNIdxColl = ^TNIdxColl;   {Topic pos collection}
 TNIdxColl = Object(TSortedCollection)
  SoftSort: Boolean;
  function Compare(Key1, Key2: Pointer): Integer; virtual;
  procedure FreeItem(Item: Pointer); virtual;
 end;

var
 T, O: Text;
 Idx: PIdxColl;
 NIdx: PNIdxColl;
 ExcludeCats, Intlist, OutFile: String;

function TIdxColl.Compare(Key1, Key2: Pointer): Integer;
var
 S1, S2 : String[20];
begin
 S1 := Copy(TIdxItem(Key1^).Topic^, 3, 255);
 S2 := Copy(TIdxItem(Key2^).Topic^, 3, 255);
 if SoftSort then
  begin
    case S2[1] of
     'I':      begin
                if Pos('AH',S2) <> 0 then S2[0] := #7
                else if Pos('AX',S2) <> 0 then S2[0] := #9
                     else S2[0] := #3;
               end;
     'P':      S2[0] := #5;
     'R':      S2[0] := #3;
     'S':      S2[0] := #1;
     'M', 'a': S2[0] := #9;
    end; {case}
    if Pos(S2, S1) <> 0 then Compare := 0
     else if S1 > S2 then Compare := 1
          else if S1 < S2 then Compare := -1;
  end
 else if S1 = S2 then Compare := 0
      else if (S1[1] = 'I') and (S2[1] = 'I') and
              (Copy(S1, 1, 4) = Copy(S2, 1, 4)) then
            if (Copy(S1, 6, 2) > Copy(S2, 6, 2)) then Compare := 1
            else if (Copy(S1, 6, 2) < Copy(S2, 6, 2)) then Compare := -1
                 else if S1 > S2 then Compare := 1
                      else if S1 < S2 then Compare := -1
                           else Compare := 0
       else if S1 > S2 then Compare := 1
            else if S1 < S2 then Compare := -1
                 else Compare := 0
end;

procedure TIdxColl.FreeItem(Item: Pointer);
begin
 if Item <> Nil then
  begin
   DisposeStr(TIdxItem(Item^).Topic);
   DisposeStr(TIdxItem(Item^).Owner);
   FreeMem(Item, SizeOf(TIdxItem));
  end;
end;

function TNIdxColl.Compare(Key1, Key2: Pointer): Integer;
begin
 if Longint(Key1) > Longint(Key2) then Compare := 1
 else if Longint(Key1) < Longint(Key2) then Compare := -1
      else Compare := 0
end;

procedure TNIdxColl.FreeItem(Item: Pointer);
begin
end;


function Topic(S: String): String;
var
 i, ps : Byte;
 SS: String;
begin
  if S[11] = '@' then S[11] := 'a';
  if S[11] in ['M', 'm', 'a'] then
   begin
    SS := HexB(Byte(S[9])) + Copy(S, 11, 9);
    if SS[3] = 'm' then SS[3] := 'M';
   end
  else if S[11] = 'P' then
        begin
         if S[16] = '-' then
          SS := HexB(Byte(S[9]))  + Copy(S, 11, 5)
         else
          SS := HexB(Byte(S[9]))  + Copy(S, 11, 9);
        end
       else if S[11] = 'R' then SS := HexB(Byte(S[9]))  + Copy(S, 11, 3)
            else if S[11] = 'S' then SS := HexB(Byte(S[9]))  + 'S'
                  else
                   begin
                    SS := HexB(Byte(S[9])) + 'I' + Copy(S,11,2);
                    if (S[13] <> '-') and (S[15] <> '-') then
                      SS := SS + 'AX'+ Copy(S,13,4)
                    else
                     begin
                      if S[13] <> '-' then SS := SS + 'AH'+ Copy(S,13,2);
                      if S[15] <> '-' then SS := SS + 'AL'+ Copy(S,15,2);
                     end;
                    for i := 17 to Length(S) do
                     if S[i] <> '-' then SS := SS + S[i];
                   end;
   ps := Pos('-', SS);
   if ps <> 0 then Topic := Copy(SS, 1, ps - 1)
   else Topic := SS;
end;

function AddTopicToIdx(Topic, Owner: String; Pos : Longint): Longint;
var
 PIdxItem: ^TIdxItem;
 Cnt: Integer;
begin
 PIdxItem := MemAlloc(SizeOf(TIdxItem));
 if PIdxItem <> Nil then
  begin
   PIdxItem^.Topic := NewStr(Topic);
   PIdxItem^.Owner := NewStr(Owner);
   PIdxItem^.Pos := Pos;
   Cnt := Idx^.Count;
   Idx^.Insert(PIdxItem);
   AddTopicToIdx := Pos;
   NIdx^.Insert(Pointer(Pos));
   if Cnt = Idx^.Count then
    begin
     WriteLn('Out of memory');
     Halt;
    end;
  end;
end;

procedure Index;
var
 T: Text;
 S, Owner: String;
 PredPos : Array[0..5] of Longint;
 Size: Longint;
 PredIdx : byte;
 pt : Byte;
begin
 Assign(T, Intlist);
 Reset(T);
 Size := TextFileSize(T);
 WriteLn('Creating index');
 PredIdx := 0;
 fillChar(PredPos, SizeOf(PredPos), 0);
 Idx^.SoftSort := False;
 while not eof(T) do
  begin
   ReadLn(T, S);
   Move(PredPos[0], PredPos[1], SizeOf(PredPos) - SizeOf(Longint));
   PredPos[0] := TextPos(T);
   Write((PredPos[0] * 100.0)/Size:-3:0,'%  '#13);
   if (Pos('--------', S) = 1) and (S[9] = '!') and
      (Pos(S[9], ExcludeCats) <> 0) then
    begin
     NIdx^.Insert(Pointer(TextPos(T)));
     Continue;
    end;
   if (Pos('--------', S) = 1) and (S[11] <> '-') then {NewTopic}
    begin
     Owner := Topic(S);
     AddTopicToIdx(Owner, '', PredPos[0])
    end
   else
    begin
     pt := Pos('(Table', S);
     if pt = 1 then
      AddTopicToIdx('  T' + Copy(S, 8, 4), Owner, PredPos[1])
     else if pt > 1 then
      AddTopicToIdx('  T' + Copy(S, pt + 7, 4), Owner, PredPos[2]);
    end;
  end;
 NIdx^.Insert(Pointer(TextPos(T)));
 Close(T);
end;


function SearchTopic(Const Topic, SubStr: String): String;
var
 Item: TIdxItem;
 PFindItem: PIdxItem;
 I, Cnt: Integer;
 T : Text;
 S : String;
begin
 SearchTopic := ' ';
 Idx^.SoftSort := False;
 Item.Topic := @Topic;
 if not Idx^.Search(@Item, I) then
  begin
   Idx^.SoftSort := True;
   if not Idx^.Search(@Item, I) then
    begin
     Idx^.SoftSort := False;
     Exit;
    end;
  end;
 Idx^.SoftSort := False;
 if SubStr = '' then  SearchTopic := 'T' + HexW(I)
 else
  begin
   Cnt := 0;
   Assign(T, Intlist);
   Reset(T);
   repeat
    Item := PIdxItem(Idx^.At(I))^;
    TextSeek(T, Item.Pos);
    ReadLn(T, S);
    if Pos(SubStr, S) <> 0 then
     begin
      SearchTopic := 'T' + HexW(I);
      Close(T);
      Exit;
     end;
    Inc(I); Inc(Cnt);
   until (I = Idx^.Count) or (Cnt > 100);
   Close(T);
  end;
end;

function SeeAlso1(Const See: String; Const CurrentTopic: String): String;
var
 S, SS, SSS: String;
 ps, fs : byte;
begin
 if Pos('#', See) = 1 then S := '  T' + Copy(See, 2, 4)
 else
  begin
   if See[1] = '@' then S := '  a' + Copy(See, 2, 4) + Copy(See, 8, 4)
   else if Pos('MEM ', See) = 1 then
          if See[10] = '' then
           S := '  M' + Copy(See, 5, 4) + Copy(See, 11, 4)
          else S := '  M'  + Copy(See, 5, 8)
        else if Pos('PORT ', See) = 1 then
               if (See[11] = '-') and (See[11] in ['0'..'F']) then
                S := '  P' + Copy(See, 6, 4) + Copy(See, 12, 4)
               else S := '  P'  + Copy(See, 6, 4)
             else if Pos('CMOS ', See) = 1 then  S := '  R' + Copy(See, 6, 2)
                  else
                   begin
                    if Pos('INT ', See) = 1 then S := '  I' + Copy(See, 5, 2)
                    else S := '  I' + Copy(CurrentTopic, 4, 2);
                    fs := 1;
                    repeat
                     ps := FIPos('=', See, fs);
                     if ps <> 0 then
                      if See[ps - 1] in ['H','L'] then
                       S := S + Copy(See, ps-2, 2) + Copy(See, ps+1, 2)
                      else S := S + Copy(See, ps-2, 2) + Copy(See, ps+1, 4);
                     fs := ps + 1;
                    until ps = 0;
                   end;
  end;
  ps := 1;
  SSS := GetLiterals(See, ps, fs);
  SeeAlso1 := SearchTopic(S, SSS);
end;

function SeeAlso(See: String; Const CurrentTopic: String): String;
var
 S, SS , SSS: String;
 ps, pps, pt : Byte;

begin
 See := ReplaceChar(':', '', See);
 See := ReplaceChar('{', '', See);
 See := ReplaceChar('}', '', See);
 pps := Length(See);
 repeat
  ps := RIPos(',', See, pps);
  S := Copy(See, ps+1, pps - ps);
  SSS := SeeAlso1(S, CurrentTopic);
  if Trim(SSS) <> '' then
   begin
    SS := ':' +  SSS + '}';
    Insert(SS, See, ps + 1 + Length(S));
    Insert('{', See, ps+1);
   end;
  pps := ps - 1;
 until ps = 0;
 SeeAlso := See;
end;

type
 Reg = record
  R : String[2];
  B : Byte;
 end;

const
 Regs : Array[0..14] of Reg =
 ((R:'AX'; B:4), (R:'AH'; B:2), (R:'AL'; B:2), (R:'BX'; B:4), (R:'BH'; B:2),
  (R:'BL'; B:2), (R:'CX'; B:4), (R:'CH'; B:2), (R:'CL'; B:2), (R:'DX'; B:4),
  (R:'DH'; B:2), (R:'DL'; B:2), (R:'SI'; B:4), (R:'DI'; B:4), (R:'BP'; B:4));

function Key(Const Topic : String) : String;
var
 I, ps : Byte;
 S : String;
begin
 S := '';
 case Topic[3] of
  'I':
   begin
    S := 'INT ' + Copy(Topic, 4, 2) + 'h ';
    if Length(Topic) > 5 then
     for i := 0 to 14 do
      With Regs[I] do
       begin
        ps := FIPos(R, Topic, 3);
        if ps <> 0 then S := S + ' '+ R + '=' + Copy(Topic, ps + 2, B);
       end;
   end;
  'M': S := 'MEM ' + Copy(Topic, 4, 4) + 'h' + Copy(Topic, 8, 4)+ 'h';
  'a': S := 'CALL ' + Copy(Topic, 4, 4) + 'h' + Copy(Topic, 8, 4)+ 'h';
  'P':
   begin
    S := 'PORT ' + Copy(Topic,4,4) + 'h';
    if Length(Topic) > 7 then S := S + ' - ' + Copy(Topic,8,4) + 'h';
   end;
  'R': S := 'CMOS ' + Copy(Topic, 4, 2) + 'h';
  'T': S := '';
 end;
  Key := S;
end;

procedure CreateOutFile;
var
 O: Text;
begin
 Assign(O, OutFile);
 Rewrite(O);
 Close(O);
end;


procedure CreateCrossReferenses;
var
 I, J, Lines, Next: Integer;
 ps, ps1: Byte;
 Item: TIdxItem;
 EndTopic, CurPos : Longint;
 T, O: Text;
 S, SS: String;
begin
 Assign(T, Intlist);
 Reset(T);
 Assign(O, OutFile);
 Append(O);
 WriteLn('Creating crossreferences');
 for I := 0 to Idx^.Count-1 do
  begin
   Item := PIdxItem(Idx^.At(I))^;
   if Item.Topic^[3] = 'S' then WriteLn(O, '.topic AllTables')
   else WriteLn(O, '.topic T' ,HexW(I));
   WriteLn(O, ';', Trim(Item.Topic^), ':', Item.Pos);
   S := Key(Item.Topic^);
   if S <> '' then WriteLn(O, '{', Key(Item.Topic^), ':Color_2}');
   TextSeek(T, Item.Pos);
   if not NIdx^.Search(Pointer(Item.Pos), J) then Exit;
   if (J+1) < NIdx^.Count then EndTopic := Longint(NIdx^.At(J+1))
   else Exit;
   if (Item.Topic^[3] = 'R') then EndTopic := MaxLongInt;
   Lines := 0; Next := 0;
   repeat
    if Lines > 250 then
     begin
      Inc(Next);  Lines := 0;
      WriteLn(O, '{Next...:T' ,HexW(I), '_', Next, '}');
      WriteLn(O, '.topic T' ,HexW(I), '_', Next);
      if Next = 1 then WriteLn(O, '{Previous...:T' ,HexW(I), '}')
      else WriteLn(O, '{Previous...:T' ,HexW(I), '_', Next - 1, '}');
     end;
    ReadLn(T, S);
    CurPos := TextPos(T);
    if (CurPos <= EndTopic) then
     begin
      if S <> '' then
       begin
        S := ReplaceChar('{', '', S);
        S := ReplaceChar('}', '', S);
        S := ReplaceChar(':', '', S);
        S := DeTab(S, 8);
       end;
      if Pos('SeeAlso ', S) = 1 then
       begin
        SS := Copy(S, 10, 255);
        WriteLn(O, ' See: ', SeeAlso(SS, Item.Topic^));
       end
      else
       begin
        ps1 := Length(S);
        repeat
         ps := RIPos('#', S, Ps1);
         if ps <> 0 then
          begin
           if Ps > 2 then Ps1 := Ps - 1
           else Break;
           SS := SeeAlso(Copy(S, ps, 5), Item.Topic^);
           if Trim(SS) <> '' then
            begin
             Delete(S, ps, 5);
             Insert(SS, S, ps);
            end;
          end;
        until ps = 0;
        if (Pos('------', S) <> 1) then
         begin
          WriteLn(O, ' ' + S);
          Inc(Lines);
         end;
       end;
     end;
   until eof(T) or (CurPos > EndTopic) or
         ((EndTopic = MaxLongInt) and (Pos('------', S) = 1));
   if Item.Owner <> Nil then
    begin
      Item.Topic := Item.Owner;
      if Idx^.Search(@Item.Owner, J) then
       begin
        Item := PIdxItem(Idx^.At(J))^;
        S := Key(Item.Topic^);
        if S <> '' then WriteLn(O, ' See: {', S, ':T', HexW(J), '}')
        else WriteLn(O, ' {Owner:T', HexW(J), '}');
       end;
    end;
   Write((100.0 * I)/Idx^.Count:-3:0, '%  '#13);
  end;
 WriteLn;
 Close(T);
 Close(O);
 Writeln('Done.');
end;


procedure CreateInterrupts;
var
 i, Lines: Integer;
 b, Next: Byte;
 Item: TIdxItem;
 O, T: Text;
 S: String;
begin
 WriteLn('Creating interrupts list');
 Assign(T, Intlist);
 Reset(T);
 Assign(O, OutFile);
 Append(O);
 WriteLn(O, '.include intlist.inc');
 for b := 0 to 255 do
  begin
   WriteLn(O, '.topic i', HexB(B));
   WriteLn(O, '');
   Lines := 0; Next := 0;
   for i := 0 to Idx^.Count - 1 do
    begin
     if Lines > 250 then
      begin
       Inc(Next);
       Lines := 0;
       WriteLn(O, '{Next...:i' ,HexB(B), '_', Next, '}');
       WriteLn(O, '.topic i' ,HexB(B), '_', Next);
       if Next = 1 then WriteLn(O, '{Previous...:i' ,HexB(B), '}')
       else WriteLn(O, '{Previous...:i' ,HexB(B), '_', Next - 1, '}');
      end;
     Write('Int ', HexB(B), ' ', (100.0 * I)/Idx^.Count:-3:0, '%  '#13);
     Item := PIdxItem(Idx^.At(I))^;
     if Pos('I' + HexB(Byte(b)), Item.Topic^) = 3 then
      begin
       TextSeek(T, Item.Pos);
       ReadLn(T, S);
       if S <> '' then
        begin
         S := ReplaceChar('{', '', S);
         S := ReplaceChar('}', '', S);
         S := ReplaceChar(':', '', S);
         S := DeTab(S, 8);
         S := ' {' + Trim(Key(Item.Topic^)) + ':T' + HexW(I) + '} ' +
                                                       Copy(S, 8, 255);
         WriteLn(O, S);
         Inc(Lines);
        end;
      end;
    end;
  end;
 WriteLn;
 Close(T);
 Close(O);
 Writeln('Done.');
end;

const
 Cats: String[50] = 'AaBbCcDdEeFfGgHhIiJjKklMmNnOPpQRrSsTtUuVvWXxy';

procedure CreateCategories;
var
 i, Lines: Integer;
 b, Next: Byte;
 Item: TIdxItem;
 O, T: Text;
 S, SS: String;
begin
 WriteLn('Creating categories');
 Assign(T, Intlist);
 Reset(T);
 Assign(O, OutFile);
 Append(O);
 WriteLn(O, '.include categor.inc');
 for b := 1 to length(Cats) do
  begin
   if Pos(Cats[b], ExcludeCats) <> 0 then Continue;
   if Cats[b] < 'a' then WriteLn(O, '.topic ct_', Cats[b], Cats[b])
   else WriteLn(O, '.topic ct_', Cats[b]);
   WriteLn(O, '');
   Lines := 0; Next := 0;
   for i := 0 to Idx^.Count - 1 do
    begin
     if Lines > 250 then
      begin
       Inc(Next);
       Lines := 0;
       if Cats[b] < 'a' then
        begin
         WriteLn(O, '{Next...:ct_', Cats[b], Cats[b], '_', Next, '}');
         WriteLn(O, '.topic ct_' , Cats[b], Cats[b], '_', Next);
         if Next = 1 then WriteLn(O, '{Previous...:ct_' ,Cats[b], Cats[b], '}')
         else WriteLn(O, '{Previous...:ct_' ,Cats[b], Cats[b], '_', Next - 1, '}');
        end
       else
        begin
         WriteLn(O, '{Next...:ct_', Cats[b], '_', Next, '}');
         WriteLn(O, '.topic ct_' , Cats[b], '_', Next);
         if Next = 1 then WriteLn(O, '{Previous...:ct_' ,Cats[b], '}')
         else WriteLn(O, '{Previous...:ct_' ,Cats[b], '_', Next - 1, '}');
        end;
      end;
     Write(Cats[b], ' ', (100.0 * I)/Idx^.Count:-3:0, '%  '#13);
     Item := PIdxItem(Idx^.At(I))^;
     if Pos(HexB(Byte(Cats[b])), Item.Topic^) = 1 then
      begin
       TextSeek(T, Item.Pos);
       ReadLn(T, S);
       if S <> '' then
        begin
         S := ReplaceChar('{', '', S);
         S := ReplaceChar('}', '', S);
         S := ReplaceChar(':', '', S);
         S := DeTab(S, 8);
         if Item.Topic^[3] = 'I' then
              S := ' {' + Trim(Key(Item.Topic^)) + ':T' + HexW(I) + '} ' +
                    Copy(S, 8, 255)
         else S := ' {'+ S + ':T' + HexW(I) + '}';
         WriteLn(O, S);
         Inc(Lines);
        end;
      end;
    end;
  end;
 WriteLn;
 Close(T);
 Close(O);
 Writeln('Done.');
end;


procedure CreateList(Class: Char);
var
 i, Lines: Integer;
 b, Next: Byte;
 Item: TIdxItem;
 O, T: Text;
 S: String;
begin
 Assign(T, Intlist);
 Reset(T);
 Assign(O, OutFile);
 Append(O);
 case Class of
 'M':
  begin
   WriteLn('Creating memory map');
   WriteLn(O, '.topic MemMap, cl_', Class);
  end;
 'T':
  begin
   WriteLn('Creating tables list');
   WriteLn(O, '.topic Tables, cl_', Class);
  end;
 'a':
  begin
   WriteLn('Creating calls list');
   WriteLn(O, '.topic Calls, cl_', Class);
  end;
 'P':
  begin
   WriteLn('Creating ports list');
   WriteLn(O, '.topic ports, cl_', Class);
  end;
 'R':
  begin
   WriteLn('Creating CMOS list');
   WriteLn(O, '.topic CMOS, cl_', Class);
  end;
 end;
 WriteLn(O, '');
 Lines := 0; Next := 0;
 for i := 0 to Idx^.Count - 1 do
  begin
   if Lines > 250 then
    begin
     Inc(Next);
     Lines := 0;
     WriteLn(O, '{Next...:cl_', Class, '_', Next, '}');
     WriteLn(O, '.topic cl_' , Class, '_', Next);
     if Next = 1 then WriteLn(O, '{Previous...:cl_' , Class, '}')
     else WriteLn(O, '{Previous...:cl_' , Class, '_', Next - 1, '}');
    end;
   Write((100.0 * I)/Idx^.Count:-3:0, '%  '#13);
   Item := PIdxItem(Idx^.At(I))^;
   if Pos(Class, Item.Topic^) = 3 then
    begin
     TextSeek(T, Item.Pos);
     ReadLn(T, S);
     if (Class = 'T') and ((S[1] = '(') or (S = '')) then ReadLn(T, S);
     if S <> '' then
      begin
       S := ReplaceChar('{', '', S);
       S := ReplaceChar('}', '', S);
       S := ReplaceChar(':', '', S);
       S := DeTab(S, 8);
       S := Trim(S);
       if S[Length(S)] = '' then Dec(S[0]);
       WriteLn(O,' {'+ S + ':T' + HexW(I) + '}');
       Inc(Lines);
      end;
    end;
  end;
 WriteLn;
 Close(T);
 Close(O);
 Writeln('Done.');
end;

procedure CommStr;
var
 PComm: PString;
 Ps, i: Byte;
begin
 ExcludeCats := '';
 PComm := Ptr(PrefixSeg, $80);
 Ps := Pos('/', PComm^);
 if Ps <> 0 then
  begin
   for i := Ps + 1 to Length(PComm^) do
    ExcludeCats := ExcludeCats + PComm^[i];
   Delete(PComm^, Ps, i);
  end;
end;

begin
 WriteLn('Interrupt list to CNHC helpfile compiler.');
 WriteLn('Copiright (C), 1996, Dmitry Orlov, 2:461/27');
 WriteLn('RB2CNHC intlist helpfile [/Exlude categories]');
 CommStr;
 if ParamCount < 2 then Halt;
 IntList := ParamStr(1); OutFile := ParamStr(2);
 Idx := New(PIdxColl, Init(10, 10));
 NIdx := New(PNIdxColl, Init(16300, 0));
 Idx^.Duplicates := True;
 Index;
 Writeln('Done. ', Idx^.Count, ' topics founded.');
 CreateOutFile;

 CreateInterrupts;
 CreateCategories;
 CreateList('T');
 CreateList('M');
 CreateList('a');
 CreateList('P');
 CreateList('R');

 CreateCrossReferenses;
 Dispose(NIdx, Done);
 Dispose(Idx, Done);
 Writeln('Done.');
end.
